(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "react", "./ColorPicker.styled.js"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var react_1 = require("react");
    var ColorPicker_styled_js_1 = require("./ColorPicker.styled.js");
    function ColorPicker(_a) {
        var _b = _a.size, size = _b === void 0 ? 34 : _b, color = _a.color, _c = _a.onChange, onChange = _c === void 0 ? function (e) { } : _c;
        var inputRef = (0, react_1.useRef)(null);
        var emitClick = function () {
            if (inputRef.current) {
                inputRef.current.click();
            }
        };
        return (<ColorPicker_styled_js_1.ColorPickerS size={size} onClick={emitClick}>
      <ColorPicker_styled_js_1.ColorLabelS size={size} color={color}></ColorPicker_styled_js_1.ColorLabelS>
      <input ref={inputRef} style={{ opacity: 0, position: 'absolute', bottom: '-1px', width: '1px', height: '1px' }} type="color" name="color" id="color" onChange={function (e) { return onChange(e.target.value, e); }}/>
    </ColorPicker_styled_js_1.ColorPickerS>);
    }
    exports.default = ColorPicker;
});
//# sourceMappingURL=ColorPicker.js.map