(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "react", "react-pdf/dist/esm/entry.webpack", "react-pdf", "./index.module.scss", "./../images/back.svg", "./../images/next.svg"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var react_1 = require("react");
    var entry_webpack_1 = require("react-pdf/dist/esm/entry.webpack");
    var react_pdf_1 = require("react-pdf");
    var index_module_scss_1 = require("./index.module.scss");
    var back_svg_1 = require("./../images/back.svg");
    var next_svg_1 = require("./../images/next.svg");
    react_pdf_1.pdfjs.GlobalWorkerOptions.workerSrc = "//cdnjs.cloudflare.com/ajax/libs/pdf.js/".concat(react_pdf_1.pdfjs.version, "/pdf.worker.js");
    var PDFReader = function (_a) {
        var fileReaderInfo = _a.fileReaderInfo, updateFileReaderInfo = _a.updateFileReaderInfo, onPageChange = _a.onPageChange;
        function onRenderSuccess() {
            var importPDFCanvas = document.querySelector('.import-pdf-page canvas');
            var pdfAsImageSrc = importPDFCanvas.toDataURL();
            updateFileReaderInfo({ currentPage: pdfAsImageSrc });
        }
        function onDocumentLoadSuccess(_a) {
            var numPages = _a.numPages;
            console.log('onDocumentLoadSuccess', numPages);
            updateFileReaderInfo({ totalPages: numPages });
        }
        function changePage(offset) {
            onPageChange(fileReaderInfo.currentPageNumber + offset);
        }
        var nextPage = function () { return changePage(1); };
        var previousPage = function () { return changePage(-1); };
        return (<div className={index_module_scss_1.default.pdfReader}>
      <div className={index_module_scss_1.default.fileContainer}>
        <entry_webpack_1.Document className={index_module_scss_1.default.document} file={fileReaderInfo.file} onLoadSuccess={onDocumentLoadSuccess} onLoadProgress={function (_a) {
                var loaded = _a.loaded, total = _a.total;
                return console.log('Loading a document: ' + (loaded / total) * 100 + '%');
            }}>
          <entry_webpack_1.Page className="import-pdf-page" onRenderSuccess={onRenderSuccess} pageNumber={fileReaderInfo.currentPageNumber}/>
        </entry_webpack_1.Document>
      </div>
      {fileReaderInfo.totalPages > 1 && (<div className={index_module_scss_1.default.pageInfo}>
          <button type="button" disabled={fileReaderInfo.currentPageNumber <= 1} onClick={previousPage}>
            <img src={back_svg_1.default} alt="Back"/>
          </button>
          <span className={index_module_scss_1.default.pageInfoDetails}>
            Page&nbsp;<b>{fileReaderInfo.currentPageNumber}</b>&nbsp;of{' '}
            {fileReaderInfo.totalPages || '--'}
          </span>
          <button type="button" disabled={fileReaderInfo.currentPageNumber >= fileReaderInfo.totalPages} onClick={nextPage}>
            <img src={next_svg_1.default} alt="Next"/>
          </button>
        </div>)}
    </div>);
    };
    exports.default = PDFReader;
});
//# sourceMappingURL=PdfReader.js.map