var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "react", "prop-types", "./Whiteboard.styled", "fabric-all-modules", "../PdfReader", "file-saver", "./Board.Class.js", "../ColorPicker", "./../images/cross.svg", "./../images/eraser.svg", "./../images/text.svg", "./../images/rectangle.svg", "./../images/line.svg", "./../images/ellipse.svg", "./../images/triangle.svg", "./../images/pencil.svg", "./../images/delete.svg", "./../images/zoom-in.svg", "./../images/zoom-out.svg", "./../images/download.svg", "./../images/add-photo.svg", "./../images/color-fill.svg"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var react_1 = require("react");
    var prop_types_1 = require("prop-types");
    var Whiteboard_styled_1 = require("./Whiteboard.styled");
    var fabric_all_modules_1 = require("fabric-all-modules");
    var PdfReader_1 = require("../PdfReader");
    var file_saver_1 = require("file-saver");
    var Board_Class_js_1 = require("./Board.Class.js");
    var ColorPicker_1 = require("../ColorPicker");
    var cross_svg_1 = require("./../images/cross.svg");
    var eraser_svg_1 = require("./../images/eraser.svg");
    var text_svg_1 = require("./../images/text.svg");
    var rectangle_svg_1 = require("./../images/rectangle.svg");
    var line_svg_1 = require("./../images/line.svg");
    var ellipse_svg_1 = require("./../images/ellipse.svg");
    var triangle_svg_1 = require("./../images/triangle.svg");
    var pencil_svg_1 = require("./../images/pencil.svg");
    var delete_svg_1 = require("./../images/delete.svg");
    var zoom_in_svg_1 = require("./../images/zoom-in.svg");
    var zoom_out_svg_1 = require("./../images/zoom-out.svg");
    var download_svg_1 = require("./../images/download.svg");
    var add_photo_svg_1 = require("./../images/add-photo.svg");
    var color_fill_svg_1 = require("./../images/color-fill.svg");
    var initFileInfo = {
        file: { name: 'whiteboard' },
        totalPages: 1,
        currentPageNumber: 0,
        currentPage: '',
    };
    var initDrawingSettings = {
        brushWidth: 5,
        currentMode: 'PENCIL',
        currentColor: '#000000',
        brushWidth: 5,
        fill: false,
    };
    var initSettings = {
        zoom: 1,
        contentJSON: null,
    };
    var Whiteboard = function (_a) {
        var controls = _a.controls, settings = _a.settings, drawingSettings = _a.drawingSettings, fileInfo = _a.fileInfo, _b = _a.onObjectAdded, onObjectAdded = _b === void 0 ? function (data, event, canvas) { } : _b, _c = _a.onObjectRemoved, onObjectRemoved = _c === void 0 ? function (data, event, canvas) { } : _c, _d = _a.onObjectModified, onObjectModified = _d === void 0 ? function (data, event, canvas) { } : _d, _e = _a.onCanvasRender, onCanvasRender = _e === void 0 ? function (data, event, canvas) { } : _e, _f = _a.onCanvasChange, onCanvasChange = _f === void 0 ? function (data, event, canvas) { } : _f, _g = _a.onZoom, onZoom = _g === void 0 ? function (data, event, canvas) { } : _g, _h = _a.onImageUploaded, onImageUploaded = _h === void 0 ? function (data, event, canvas) { } : _h, _j = _a.onPDFUploaded, onPDFUploaded = _j === void 0 ? function (data, event, canvas) { } : _j, _k = _a.onPDFUpdated, onPDFUpdated = _k === void 0 ? function (data, event, canvas) { } : _k, _l = _a.onPageChange, onPageChange = _l === void 0 ? function (data, event, canvas) { } : _l, _m = _a.onOptionsChange, onOptionsChange = _m === void 0 ? function (data, event, canvas) { } : _m, _o = _a.onSaveCanvasAsImage, onSaveCanvasAsImage = _o === void 0 ? function (data, event, canvas) { } : _o, _p = _a.onConfigChange, onConfigChange = _p === void 0 ? function (data, event, canvas) { } : _p, _q = _a.onSaveCanvasState, onSaveCanvasState = _q === void 0 ? function (data, event, canvas) { } : _q;
        var _r = (0, react_1.useState)(), board = _r[0], setBoard = _r[1];
        var _s = (0, react_1.useState)({}), canvasObjectsPerPage = _s[0], setCanvasObjectsPerPage = _s[1];
        var _t = (0, react_1.useState)(__assign(__assign({}, initDrawingSettings), drawingSettings)), canvasDrawingSettings = _t[0], setCanvasDrawingSettings = _t[1];
        var canvasConfig = __assign(__assign({}, initSettings), settings);
        var _u = (0, react_1.useState)(canvasConfig.zoom), zoom = _u[0], setZoom = _u[1];
        var _v = (0, react_1.useState)(__assign(__assign({}, initFileInfo), fileInfo)), fileReaderInfo = _v[0], setFileReaderInfo = _v[1];
        var canvasRef = (0, react_1.useRef)(null);
        var whiteboardRef = (0, react_1.useRef)(null);
        var uploadPdfRef = (0, react_1.useRef)(null);
        var enabledControls = (0, react_1.useMemo)(function () {
            var _a;
            return __assign((_a = {}, _a[Board_Class_js_1.modes.PENCIL] = true, _a[Board_Class_js_1.modes.LINE] = true, _a[Board_Class_js_1.modes.RECTANGLE] = true, _a[Board_Class_js_1.modes.ELLIPSE] = true, _a[Board_Class_js_1.modes.TRIANGLE] = true, _a[Board_Class_js_1.modes.TEXT] = true, _a[Board_Class_js_1.modes.SELECT] = true, _a[Board_Class_js_1.modes.ERASER] = true, _a.CLEAR = true, _a.FILL = true, _a.BRUSH = true, _a.COLOR_PICKER = true, _a.DEFAULT_COLORS = true, _a.FILES = true, _a.SAVE_AS_IMAGE = true, _a.ZOOM = true, _a), controls);
        }, [controls]);
        (0, react_1.useEffect)(function () {
            setCanvasDrawingSettings(__assign(__assign({}, canvasDrawingSettings), drawingSettings));
        }, [drawingSettings]);
        (0, react_1.useEffect)(function () {
            if (!board || !canvasConfig)
                return;
            board.setCanvasConfig(canvasConfig);
        }, [settings]);
        (0, react_1.useEffect)(function () {
            setFileReaderInfo(__assign(__assign({}, fileReaderInfo), fileInfo));
        }, [fileInfo]);
        (0, react_1.useEffect)(function () {
            if (board) {
                return;
            }
            var newBoard = new Board_Class_js_1.Board({
                drawingSettings: canvasDrawingSettings,
                canvasConfig: canvasConfig,
            });
            setBoard(newBoard);
            addListeners(newBoard.canvas);
            return function () {
                if (board) {
                    board.removeBoard();
                }
            };
        }, [board]);
        (0, react_1.useEffect)(function () {
            if (!board || !canvasDrawingSettings)
                return;
            board.setDrawingSettings(canvasDrawingSettings);
        }, [canvasDrawingSettings, board]);
        (0, react_1.useEffect)(function () {
            if (!(board === null || board === void 0 ? void 0 : board.canvas) || !fileReaderInfo.currentPage) {
                return;
            }
            var json = getPageJSON({
                fileName: fileReaderInfo.file.name,
                pageNumber: fileReaderInfo.currentPageNumber,
            });
            if (json) {
                board.canvas.loadFromJSON(json);
            }
            else {
                board.openPage(fileReaderInfo.currentPage);
            }
        }, [fileReaderInfo.currentPage]);
        function uploadImage(e) {
            var reader = new FileReader();
            var file = e.target.files[0];
            reader.addEventListener('load', function () {
                fabric_all_modules_1.fabric.Image.fromURL(reader.result, function (img) {
                    img.scaleToHeight(board.canvas.height);
                    board.canvas.add(img);
                });
            });
            reader.readAsDataURL(file);
        }
        function addListeners(canvas) {
            canvas.on('after:render', function (e) {
                var data = getFullData(canvas);
                onCanvasRender(data, e, canvas);
            });
            canvas.on('zoom:change', function (data) {
                onZoom(data, null, canvas);
                setZoom(data.scale);
            });
            canvas.on('object:added', function (event) {
                onObjectAdded(event.target.toJSON(), event, canvas);
                onCanvasChange(event.target.toJSON(), event, canvas);
            });
            canvas.on('object:removed', function (event) {
                onObjectRemoved(event.target.toJSON(), event, canvas);
                onCanvasChange(event.target.toJSON(), event, canvas);
            });
            canvas.on('object:modified', function (event) {
                onObjectModified(event.target.toJSON(), event, canvas);
                onCanvasChange(event.target.toJSON(), event, canvas);
            });
        }
        function getFullData(canvas) {
            if (!canvas)
                return;
            return {
                settings: {
                    contentJSON: canvas.toJSON(),
                    viewportTransform: canvas.viewportTransform,
                },
                drawingSettings: canvasDrawingSettings,
                fileInfo: fileReaderInfo,
            };
        }
        function saveCanvasState() {
            var _a, _b;
            var newValue = __assign(__assign({}, canvasObjectsPerPage), (_a = {}, _a[fileReaderInfo.file.name] = __assign(__assign({}, canvasObjectsPerPage[fileReaderInfo.file.name]), (_b = {}, _b[fileReaderInfo.currentPageNumber] = board.canvas.toJSON(), _b)), _a));
            setCanvasObjectsPerPage(newValue);
            onSaveCanvasState(newValue);
        }
        function changeBrushWidth(e) {
            var intValue = parseInt(e.target.value);
            board.canvas.freeDrawingBrush.width = intValue;
            var newOptions = __assign(__assign({}, canvasDrawingSettings), { brushWidth: intValue });
            setCanvasDrawingSettings(newOptions);
            onOptionsChange(newOptions, e, board.canvas);
        }
        function changeMode(mode, e) {
            if (canvasDrawingSettings.currentMode === mode)
                return;
            var newOptions = __assign(__assign({}, canvasDrawingSettings), { currentMode: mode });
            setCanvasDrawingSettings(newOptions);
            onOptionsChange(newOptions, e, board.canvas);
        }
        function changeCurrentColor(color, e) {
            board.canvas.freeDrawingBrush.color = color;
            var newOptions = __assign(__assign({}, canvasDrawingSettings), { currentColor: color });
            setCanvasDrawingSettings(newOptions);
            onOptionsChange(newOptions, e, board.canvas);
        }
        function changeFill(e) {
            var newOptions = __assign(__assign({}, canvasDrawingSettings), { fill: !canvasDrawingSettings.fill });
            setCanvasDrawingSettings(newOptions);
            onOptionsChange(newOptions, e, board.canvas);
        }
        function handleSaveCanvasAsImage() {
            canvasRef.current.toBlob(function (blob) {
                (0, file_saver_1.saveAs)(blob, "".concat(fileReaderInfo.file.name).concat(fileReaderInfo.currentPage ? '_page-' : '', ".png"));
                onSaveCanvasAsImage(blob, null, board.canvas);
            });
        }
        function onFileChange(event) {
            if (!event.target.files[0])
                return;
            if (event.target.files[0].type.includes('image/')) {
                uploadImage(event);
                onImageUploaded(event.target.files[0], event, board.canvas);
            }
            else if (event.target.files[0].type.includes('pdf')) {
                saveCanvasState();
                board.clearCanvas();
                updateFileReaderInfo({ file: event.target.files[0], currentPageNumber: 1 });
                onPDFUploaded(event.target.files[0], event, board.canvas);
            }
        }
        function getPageJSON(_a) {
            var fileName = _a.fileName, pageNumber = _a.pageNumber;
            if (canvasObjectsPerPage[fileName] && canvasObjectsPerPage[fileName][pageNumber]) {
                return canvasObjectsPerPage[fileName][pageNumber];
            }
            else {
                return null;
            }
        }
        function updateFileReaderInfo(data) {
            var newFileData = __assign(__assign({}, fileReaderInfo), data);
            setFileReaderInfo(newFileData);
            onPDFUpdated(newFileData, null, board.canvas);
        }
        var handlePageChange = function (page) {
            saveCanvasState();
            board.clearCanvas(board.canvas);
            setFileReaderInfo(__assign(__assign({}, fileReaderInfo), { currentPageNumber: page }));
            onPageChange(__assign(__assign({}, fileReaderInfo), { currentPageNumber: page }), null, board.canvas);
        };
        var handleZoomIn = function () {
            board.changeZoom({ scale: 1.1 });
        };
        var handleZoomOut = function () {
            board.changeZoom({ scale: 0.9 });
        };
        var handleResetZoom = function () {
            board.resetZoom(1);
        };
        var getColorButtons = function (colors) {
            return colors.map(function (color) { return (<Whiteboard_styled_1.ToolbarItemS key={color}>
        <Whiteboard_styled_1.ColorButtonS color={color} onClick={function (e) { return changeCurrentColor(color, e); }}/>
      </Whiteboard_styled_1.ToolbarItemS>); });
        };
        var getControls = function () {
            var _a;
            var modeButtons = (_a = {},
                _a[Board_Class_js_1.modes.PENCIL] = { icon: pencil_svg_1.default, name: 'Pencil' },
                _a[Board_Class_js_1.modes.LINE] = { icon: line_svg_1.default, name: 'Line' },
                _a[Board_Class_js_1.modes.RECTANGLE] = { icon: rectangle_svg_1.default, name: 'Rectangle' },
                _a[Board_Class_js_1.modes.ELLIPSE] = { icon: ellipse_svg_1.default, name: 'Ellipse' },
                _a[Board_Class_js_1.modes.TRIANGLE] = { icon: triangle_svg_1.default, name: 'Triangle' },
                _a[Board_Class_js_1.modes.TEXT] = { icon: text_svg_1.default, name: 'Text' },
                _a[Board_Class_js_1.modes.SELECT] = { icon: cross_svg_1.default, name: 'Select' },
                _a[Board_Class_js_1.modes.ERASER] = { icon: eraser_svg_1.default, name: 'Eraser' },
                _a);
            return Object.keys(modeButtons).map(function (buttonKey) {
                if (!enabledControls[buttonKey])
                    return;
                var btn = modeButtons[buttonKey];
                return (<Whiteboard_styled_1.ButtonS key={buttonKey} type="button" className={"".concat(canvasDrawingSettings.currentMode === buttonKey ? 'selected' : '')} onClick={function (e) { return changeMode(buttonKey, e); }}>
          <img src={btn.icon} alt={btn.name}/>
        </Whiteboard_styled_1.ButtonS>);
            });
        };
        return (<Whiteboard_styled_1.WhiteBoardS ref={whiteboardRef}>
      <Whiteboard_styled_1.ToolbarHolderS>
        <Whiteboard_styled_1.ColorBarS>
          {!!enabledControls.COLOR_PICKER && (<Whiteboard_styled_1.ToolbarItemS>
              <ColorPicker_1.ColorPicker size={28} color={canvasDrawingSettings.currentColor} onChange={changeCurrentColor}></ColorPicker_1.ColorPicker>
            </Whiteboard_styled_1.ToolbarItemS>)}
          {!!enabledControls.BRUSH && (<Whiteboard_styled_1.ToolbarItemS>
              <Whiteboard_styled_1.RangeInputS type="range" min={1} max={30} step={1} thumbColor={canvasDrawingSettings.currentColor} value={canvasDrawingSettings.brushWidth} onChange={changeBrushWidth}/>
            </Whiteboard_styled_1.ToolbarItemS>)}
          {!!enabledControls.DEFAULT_COLORS && (<>{getColorButtons(['#6161ff', '#ff4f4f', '#3fd18d', '#ec70ff', '#000000'])}</>)}
          {!!enabledControls.FILL && (<Whiteboard_styled_1.ButtonS type="button" className={canvasDrawingSettings.fill ? 'selected' : ''} onClick={changeFill}>
              <img src={color_fill_svg_1.default} alt="Delete"/>
            </Whiteboard_styled_1.ButtonS>)}
        </Whiteboard_styled_1.ColorBarS>
        <Whiteboard_styled_1.ToolbarS>
          {getControls()}

          {!!enabledControls.CLEAR && (<Whiteboard_styled_1.ButtonS type="button" onClick={function () { return board.clearCanvas(); }}>
              <img src={delete_svg_1.default} alt="Delete"/>
            </Whiteboard_styled_1.ButtonS>)}

          <Whiteboard_styled_1.SeparatorS />

          {!!enabledControls.FILES && (<Whiteboard_styled_1.ToolbarItemS>
              <input ref={uploadPdfRef} hidden accept="image/*,.pdf" type="file" onChange={onFileChange}/>
              <Whiteboard_styled_1.ButtonS onClick={function () { return uploadPdfRef.current.click(); }}>
                <img src={add_photo_svg_1.default} alt="Delete"/>
              </Whiteboard_styled_1.ButtonS>
            </Whiteboard_styled_1.ToolbarItemS>)}

          {!!enabledControls.SAVE_AS_IMAGE && (<Whiteboard_styled_1.ToolbarItemS>
              <Whiteboard_styled_1.ButtonS onClick={handleSaveCanvasAsImage}>
                <img src={download_svg_1.default} alt="Download"/>
              </Whiteboard_styled_1.ButtonS>
            </Whiteboard_styled_1.ToolbarItemS>)}
        </Whiteboard_styled_1.ToolbarS>
        <Whiteboard_styled_1.ZoomBarS>
          {!!enabledControls.ZOOM && (<Whiteboard_styled_1.ToolbarItemS>
              <Whiteboard_styled_1.ButtonS onClick={handleZoomIn} title="Zoom In">
                <img src={zoom_in_svg_1.default} alt="Zoom In"/>
              </Whiteboard_styled_1.ButtonS>
            </Whiteboard_styled_1.ToolbarItemS>)}

          {!!enabledControls.ZOOM && (<Whiteboard_styled_1.ToolbarItemS>
              <Whiteboard_styled_1.ButtonS onClick={handleResetZoom} title="Reset Zoom">
                <span style={{ fontSize: '11px' }}>{Math.floor(zoom * 100)}%</span>
              </Whiteboard_styled_1.ButtonS>
            </Whiteboard_styled_1.ToolbarItemS>)}

          {!!enabledControls.ZOOM && (<Whiteboard_styled_1.ToolbarItemS>
              <Whiteboard_styled_1.ButtonS onClick={handleZoomOut} title="Zoom Out">
                <img src={zoom_out_svg_1.default} alt="Zoom Out"/>
              </Whiteboard_styled_1.ButtonS>
            </Whiteboard_styled_1.ToolbarItemS>)}
        </Whiteboard_styled_1.ZoomBarS>
      </Whiteboard_styled_1.ToolbarHolderS>

      <canvas ref={canvasRef} id="canvas"/>
      <Whiteboard_styled_1.PDFWrapperS>
        <PdfReader_1.PdfReader fileReaderInfo={fileReaderInfo} onPageChange={handlePageChange} updateFileReaderInfo={updateFileReaderInfo}/>
      </Whiteboard_styled_1.PDFWrapperS>
    </Whiteboard_styled_1.WhiteBoardS>);
    };
    Whiteboard.propTypes = {
        aspectRatio: prop_types_1.default.number,
    };
    exports.default = Whiteboard;
});
//# sourceMappingURL=Whiteboard.js.map